#! /depot/langs/arch/bin/pfe -q

( fgrep in ANS-Forth )
( Keith Waclena <k-waclena@uchicago.edu> )

: K 1024 * ;

20 K 2 + constant MAXLINE
variable line MAXLINE chars allot

( get-line: takes buffer address, length and fileid; reads next line from fileid )
( into buffer; returns buffer address, length of string read, and flag )

: get-line		( c-addr u fileid -- c-addr u flag )
  rot dup >r rot rot 	( c-addr u fileid )
  read-line swap if	( u ior )
    drop r> swap true	( c-addr u flag )
  else
    drop r> swap false	( c-addr u flag )
  then
;

( search for c-addr2 in c-addr1; return success )

: found			( c-addr1 u1 c-addr2 u2 -- c-addr1 u1 flag )
  2over 2swap search rot rot 2drop
;

: fgrep-f			( c-addr u fileid -- fileid )
  begin
    line over MAXLINE swap get-line
  while				( c-addr1 u1 fileid c-addr2 u2 )
    4 pick 4 pick		( c-addr1 u1 fileid c-addr2 u2 c-addr1 u1 )
    found if			( c-addr1 u1 fileid caddr1 u1 )
      type
    else
      2drop
    then
  repeat
  2drop rot rot 2drop
;

: fgrep			( c-addr u c-addr u -- )	\ pattern filename --
  r/o open-file abort" no such file or file not readable"  ( c-addr1 u1 fileid )
  fgrep-f
  close-file drop
;

\ : main
\   argc 3 <> abort" Usage: fgrep pattern file"
\   1 argv 2 argv fgrep
\   bye
\ ;
\ 
\ main

